<template>
    <b-modal
        v-model="show"
        hide-footer
        title="Send Test"
        @hidden="close"
    >
        <div class="popup-body-container">
            <div class="send-action-container">
                <template v-if="phoneType">
                    <div class="tag-container">
                        <FormTags ref="formTags" :item="{placeholder: 'Phone Number'}" v-model="smsValue" @input="getRegionAveragePrice"/>
                        <div v-if="averagePrice">
                            <img
                                v-if="allWorld"
                                class="flag-image"
                                src="/images/earth.png"
                                alt=""
                            >
                            <img
                                v-else
                                class="flag-image"
                                :src="`/images/flags/${this.country}.png`"
                                alt=""
                            >
                        </div>
                    </div>
                    <p
                        v-if="averagePrice"
                        class="mt-2 mb-0 average-price"
                    >
                        {{ averagePrice }}$ for
                        <span v-if="smsValue.length > 1">{{ smsValue.length }}</span>
                        <span v-else>each</span>
                        SMS
                    </p>
                </template>
                <input
                    v-else-if="input"
                    v-model="item"
                    class="form-control"
                    :type="input.type"
                    :placeholder="input.placeholder"
                >
                <div class="send-action__actions">
                    <div class="send-action__notif">
                        <span v-show="showText"><slot name="unsaved"/></span>
                        <span v-show="showMaxPriceNotification">
                            Heads up! The cost of this test SMS is higher than the maximum SMS price that you defined. You can send it anyway. To update maximum SMS price navigate to the Settings page.
                        </span>
                    </div>
                    <button
                        :disabled="disabled"
                        class="btn blue-btn"
                        :class="{'loading-xs': loading}"
                        type="button"
                        @click="send"
                    >
                        <template v-if="!loading">
                            Send
                        </template>
                    </button>
                </div>
            </div>
        </div>

    </b-modal>
</template>

<script>
import smsReminders from "@/mixins/sms/abandoned-carts.service";
import FormTags from '@/components/elements/FormTags.vue'

export default {
    mixins: [smsReminders],
    props: ['input', 'showText', 'type'],
    data() {
        return {
            item: '',
            show: false,
            smsValue: [],
            averagePrice: null,
            country: null,
            disabledCountries: null,
            allWorld: false,
            loading: false,
        }
    },
    components: {
        FormTags
    },
    computed: {
        phoneType() {
            return this.type === 'phone'
        },
        disabled() {
            if(this.phoneType) return !this.smsValue || !this.smsValue.length || !this.averagePrice
            return this.item == ''
        },
        showMaxPriceNotification() {
            const max_sms_price = this.$store.state.shop.shop.max_sms_price
            if(max_sms_price && this.averagePrice && this.averagePrice > parseFloat(max_sms_price)) return true
            return false
        }
    },
    created() {
        this.show = true
    },
    methods: {
        send() {
            let data
            if(this.phoneType) {
                const {smsValue, averagePrice, disabledCountries} = this.$data
                data = {smsValue, averagePrice, disabledCountries}
            } else data = this.item
            this.loading = true
            this.clearData()
            this.$emit('send', data)
        },
        close() {
            this.$emit('close')
        },
        stopLoading() {
            this.loading = false
        },
        clearData() {
            this.country = null
            this.averagePrice = null
            this.allWorld = false
            this.smsValue = []
        },
        async getRegionAveragePrice() {
            if(this.smsValue && this.smsValue.length) {
                try {
                    const response = await this.getRegionAveragePriceByNumber({sms: this.smsValue})
                    this.averagePrice = response.averagePrice
                    this.country = response.country
                    this.disabledCountries = response.disabledCountries
                    this.allWorld = response.allWorld
                } catch (er) {
                    this.$refs.formTags.removeItem(this.smsValue.length - 1)
                }
            }
        },
    }

}
</script>
<style lang="scss" scoped>
.popup-body-container {
    display: flex;
    justify-content: center;
    align-items: center;
}
.send-action {
    &-container {
        display: flex;
        flex-direction: column;
        width: 100%;
    }
    &__actions {
        margin-top: 1rem;
        display: flex;
        justify-content: space-between;
        align-items: flex-end;
        span {
            display: block;
            margin-right: auto;
            opacity: 0.8;
            &:first-of-type {
                margin-bottom: 15px;
            }
        }
        .blue-btn {
            margin-left: 5px;
            padding: 0pc 20px;
            min-width: 74px;
            max-height: 43px;
        }
    }
    &__notif {
        width: calc(100% - 145px);
    }

}

</style>